


--time accumulated in hill
local timeTable = {}

--time till respawn. -1 means alive
local respawnTime = {}

--number of deaths
local deathCount = {}

--true = acu in hill false = out
local inHillTable = {}

--hill info
local centerX
local centerY
local radius

local modPath = 'KingoftheHill'
function KingoftheHill()
	--LOG('koth stuff started')
	--set up score
	local brainIndex = 0
	for army, brain in ArmyBrains do
		if ArmyIsCivilian(army) == false then
			brainIndex = brainIndex + 1
			timeTable[brainIndex] = 0
			respawnTime[brainIndex] = -1
			deathCount[brainIndex] = 0
			inHillTable[brainIndex] = false
			brain.CalculateScore = kothScore
		end
	end
	--wait for short time before voting
	--WaitSeconds(10)
	--LOG('koth done waiting')
	local sizeX, sizeY = GetMapSize()
	centerX = sizeX/2
	centerY = sizeY/2
	--prompt hill radius small, med or large TODO
	radius = sizeX/20
	--create hill markers
	CreateHill(centerX, centerY, radius)
	--prompt win time TODO
	local winTime = 500
	timeReached = false
	while timeReached ==false
	do
		brainIndex = 0
		--check in hill, add score if needed
		--if acu killed transfer score
		for army, brain in ArmyBrains do
			if ArmyIsCivilian(army) == false then
				brainIndex = brainIndex + 1
				local acu = brain:FindUnit(categories.COMMAND, false)
				if acu then
					--LOG('koth acu alive', acu)
					if inHill(acu, centerX, centerY, radius) and enemiesinHill(army) == false then
						timeTable[brainIndex] = timeTable[brainIndex] + 1
						local currentTime = timeTable[brainIndex]
						for army2, brain2 in ArmyBrains do
							if IsAlly(army, army2) and army != army2 then
								currentTime = currentTime + timeTable[getBrainIndex(brain2)]
							end
						end
						if currentTime == winTime - 60 then
							PrintText('1 minute remaining!', 20, nil, 10, 'center')
						elseif currentTime == winTime - 30 then
							PrintText('30 seconds remaining!', 20, nil, 10, 'center')
						elseif currentTime >= winTime then
							timeReached = true
							brain:OnVictory()
							WaitSeconds(5)
							EndGame()
						end
					end
				elseif respawnTime[brainIndex] == -1 then
					--LOG('koth acu died')
					--acu just died
					deathCount[brainIndex] = deathCount[brainIndex] + 1
					timeTable[brainIndex] = timeTable[brainIndex] - 200
					--spawn times increase to max of 40
					if deathCount[brainIndex] <= 3 then
						respawnTime[brainIndex] = deathCount[brainIndex] * 10
					else
						respawnTime[brainIndex] = 40
					end
				elseif respawnTime[brainIndex] == 0 then
					--LOG('koth respawn now')
					--time to respawn
					respawnACU(brain)
					respawnTime[brainIndex] = -1
				else
					--LOG('koth counting down now')
					--count down timer
					respawnTime[brainIndex] = respawnTime[brainIndex] - 1
				end
			end
		end
		WaitSeconds(1)
	end
end


function CreateHill(centerX, centerY, radius)
	--spawn some sort of item at 8 points around circle
	--local proptest = CreatePropHPR( centerX+radius+radius, 0, centerY, 0, 0, 0)
	for army, brain in ArmyBrains do
		if ArmyIsCivilian(army) == false then
			local markerN = CreateUnitHPR("ueb5101", army, centerX, 0, centerY-radius, 0, 0, 0)
			makeSafe(markerN)
			local markerE = CreateUnitHPR("uab5101", army, centerX+radius, 0, centerY, 0, 0, 0)
			makeSafe(markerE)
			local markerS = CreateUnitHPR("ueb5101", army, centerX, 0, centerY+radius, 0, 0, 0)
			makeSafe(markerS)
			local markerW = CreateUnitHPR("uab5101", army, centerX-radius, 0, centerY, 0, 0, 0)
			makeSafe(markerW)
			local markerNE = CreateUnitHPR("urb5101", army, centerX+radius*math.sqrt(2)/2, 0, centerY-radius*math.sqrt(2)/2, 0, 0, 0)
			makeSafe(markerNE)
			local markerSE = CreateUnitHPR("xsb5101", army, centerX+radius*math.sqrt(2)/2, 0, centerY+radius*math.sqrt(2)/2, 0, 0, 0)
			makeSafe(markerSE)
			local markerSW = CreateUnitHPR("urb5101", army, centerX-radius*math.sqrt(2)/2, 0, centerY+radius*math.sqrt(2)/2, 0, 0, 0)
			makeSafe(markerSW)
			local markerNW = CreateUnitHPR("xsb5101", army, centerX-radius*math.sqrt(2)/2, 0, centerY-radius*math.sqrt(2)/2, 0, 0, 0)
			makeSafe(markerNW)
		end
	end
end

function makeSafe(unit)
	unit:SetCanTakeDamage(false)
	unit:SetReclaimable(false)
	unit:SetCapturable(false)
end

function kothScore(self)
	local myIndex = getBrainIndex(self)
	return timeTable[myIndex]
end


function getBrainIndex(self)
	local brainIndex = 0
	for army, brain in ArmyBrains do
		if ArmyIsCivilian(army) == false then
			brainIndex = brainIndex + 1
			if brain == self
			then
				return brainIndex
			end
		end
	end
end

function inHill(acuiH, centerX, centerY, radius)
	local acuPos = acuiH:GetPosition()
	local dist = VDist2(acuPos[1], acuPos[3], centerX, centerY)
	if dist <= radius then
		--LOG('koth acu in hill')
		return true
	else
		--LOG('koth acu dist is', dist)
		return false
	end
end

function enemiesinHill(army)
	for army2, brain2 in ArmyBrains do
		local acu2 = brain2:FindUnit(categories.COMMAND, false)
		if acu2 and inHill(acu2, centerX, centerY, radius) and IsAlly(army, army2) == false and army != army2 then
			--LOG('koth enemies in hill')
			return true
		end
	end
	return false
end
			


function respawnACU(brain)
	--LOG('koth respawning')
	local faction = brain:GetFactionIndex()
	--LOG('koth respawn faction is', faction)
	local spawnPosX, spawnPosY = brain:GetArmyStartPos()
	local armyIndex = brain:GetArmyIndex()
	local newACU
	if faction == 2 then
		newACU = CreateUnitHPR("ual0001", armyIndex, spawnPosX + math.random(-5, 5), 0, spawnPosY + math.random(-5, 5), 0, 0, 0)
	elseif faction == 1 then
		newACU = CreateUnitHPR("uel0001", armyIndex, spawnPosX + math.random(-5, 5), 0, spawnPosY + math.random(-5, 5), 0, 0, 0)
	elseif faction == 3 then
		newACU = CreateUnitHPR("url0001", armyIndex, spawnPosX + math.random(-5, 5), 0, spawnPosY + math.random(-5, 5), 0, 0, 0)
	else
		newACU = CreateUnitHPR("xsl0001", armyIndex, spawnPosX + math.random(-5, 5), 0, spawnPosY + math.random(-5, 5), 0, 0, 0)
	end
    --local playerName = brain.nickname
	--LOG('koth name is', playerName)
    --newACU:SetCustomName(playerName)
end